#!/bin/bash

json_path="example.json" # JSON 文件路径
json_data="`jq . $json_path`" # JSON 数据

set_json() {
    [ $# -lt 2 ] && return 1 # 参数数量小于 2 返回 1
    jq -e .$1 $json >/dev/null 2>&1 || return 2 # 键值不存在返回 2
    local json_key=$1
    local json_value=""
    local line_data=$(echo "$json_data" | grep -w "\"$json_key\".*:" ) # 获取数据行
    echo "$line_data" | grep -w "\".*\".*\".*\"" >/dev/null 2>&1
    [ $? -eq 0 ] && json_value="\"$2\"" || json_value=$2 # 判断值是否为字符串
    [ "${line_data:$((${#line_data}-1))}" = "," ] && json_value="${json_value}," # 判断数据行结尾是否有逗号
    local json_new_data=$(echo "$json_data" | sed "s/$line_data/ \"$json_key\": $json_value/") # 替换数据行
    echo "$json_new_data" | jq -e . >/dev/null 2>&1 || return 3 # 校验替换后的数据 失败返回 3
    json_data="$json_new_data" && echo "$json_data" > $json_path
}

set_json "site_mivm" "米V米 - 希望可以找到你想到的"
